<template>
    <div class="card">
        <div class="card-body position-relative">
            <div v-if="!edit">
                {{answer.content}}
                <a v-if="token" class="text-muted c-answer-item__cta" v-on:click="edit=true" href="javascript:void(0);">Edit</a>
            </div>

            <div v-else="" class="">
                <answer-form :content="content" @content-saved="updateAnswer"></answer-form>
            </div>

        </div>

        <div class="card-footer bg-white justify-content-center row m-2 d-none" v-if="answer.can_rate">
            <div class="c-answer-item__rate d-flex flex-column mx-3 text-center col-3 "
                 v-on:click="$emit('rate-clicked', answer, rate)" v-for="rate in rates"
                 :class="{'c-answer-item__rate--selected':rate.value===answer.rate}">
                <div class="mb-1">
                    <img :src="rate.icon" :alt="rate.name">
                </div>
                <small>
                    {{rate.name}}
                </small>
            </div>
        </div>
    </div>
</template>

<script>
    import AnswerForm from "./AnswerForm";

    export default {
        name: "answerItem",
        components: {
            AnswerForm,
        },
        data() {
            return {
                content: this.answer.content,
                token: localStorage.getItem('token'),
                rates: [
                    {
                        icon: '/images/rates/cool.svg',
                        name: 'Nailed it.',
                        value: "expert"
                    },
                    {
                        icon: '/images/rates/happy.svg',
                        name: 'Good job.',
                        value: "intermediate"
                    },
                    {
                        icon: '/images/rates/thinking.svg',
                        name: 'Maybe try again.',
                        value: "beginner"
                    }
                ],
                edit: false


            }
        },
        props: {
            answer: {type: Object, required: true},
        },
        methods: {
            updateAnswer(newContent) {
                this.$emit('answer-updated', this.answer, newContent);
                this.edit = false;
            }
        }
    }
</script>

